# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# #                                                   # #
#   iok (inviteonknock) - Script v1.0 by stylus740      # 
# #                                                   # #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # #


#########################################################
# History:
# 1.0		Erstes Release
# 1.1       Diverse Bugs bereinigt
#########################################################

##
# veranlat den Bot bei einem KNOCK definierten Usern ein invite zu senden
##

# In welchen Channels soll das Script aktiv sein? 
# Die Definition erfolgt nicht im script, sondern durch Setzen von +iok im Bot
# In der partyline eingeben:
#
# .chanset #channel +iok

# Zur Aktivierung der userdefined flags
setudef flag iok

# Definition des Datenfiles fr berechtigte User

set iok_ni(datafile) "scripts/iok.dat"

###############################################################################
# Mgliche Befehle in der Partyline:							#
#													#
# .chanset #chan +iok		Aktivierung des scripts in Channel #chan		#
# .chanset #chan -iok		Deaktivierung des scripts in Channel #chan	#
# .iokhelp				Hilfen zur Bedienung					#
# .+iokuser				User und Text hinzufgen				#
# .-iokuser				User und Text lschen					#
# .listiokuser			Eintrge anzeigen						#
###############################################################################

### Ab hier nur editieren, wenn man genau wei, was man tut. Beginn des Codes ###

set iok_ni(version) v1.0				;# Variable fr Version setzten

bind notc - "*KNOCK*" kinvite				;# eigenliche Einladroutine	
bind dcc o|o +iokuser add_users			;# User hinzufgen
bind dcc o|o -iokuser del_users			;# User hinzufgen
bind dcc o|o listiokuser list_users			;# User anzeigen
bind dcc o|o iokhelp help_users			;# Hilfe anzeigen

proc help_users {handle idx args} {
putlog "iok ermglicht es Usern, sich direkt vom Bot in Channels mit +i einladen zu lassen, indem sie per '/knock #chan' einfach nur anklopfen. Voraussetzung hierfr ist es allerdings, dass die User in einer Liste eingetragen sind."
putlog "Die Steuerung von iok erfolgt ausschlielich ber die partyline mit den folgenden Befehlen:"
putlog " "
putlog "+iokuser <nick> <chan>        Nick mit Channel hinzufgen oder ndern"
putlog "-iokuser <nick>               Den angegebenen Nick lschen"
putlog "listiokuser                   Smtliche berechtigten User-Eintrge anzeigen"
putlog "iokhelp      	              Diese Hilfemeldung anzeigen"
}

proc init_users {} {
global iok_nick iok_ni					   ;# Datenstrukturen public definieren
if {[file exists $iok_ni(datafile)]} {		   ;# Falls File vorhanden
  putlog "Laden Userdaten aus $iok_ni(datafile)"   ;# Lademeldung
  set in [open $iok_ni(datafile) r]			   ;# Datenfile im read modus ffnen
  while {![eof $in]} {					   ;# solange kein EOF
    set vline [gets $in]                           ;# Zeile holen
    if {[eof $in]} {break}  				   ;# Falls EOF, Ende von while
    set inick [lindex $vline 0]			   ;# Nick extrahieren
    set ichan [lrange $vline 1 end]			   ;# Channel extrahieren
    set ientry "$inick&$ichan"			   ;# Kombination Nick&Chan bauen
    set iok_nick($ientry) $ientry                  ;# Array Datenfeld belegen
    }								   ;# End while
  close $in							   ;# Datei schlieen
  }								   ;# End If (dataexist)
}								   ;# End Procedure
init_users

proc list_users {handle idx args} {
global iok_nick iok_ni					   ;# Datenstrukturen public definieren
if {[info exists iok_nick]} {				   ;# Falls Felder definiert sind
  putlog "Eingetragene Nick fr iok:"		   ;# berschrift anzeigen
  foreach search [array names iok_nick] {          ;# Fr jeden Eintrag
   if {$search != 0} {					   ;# wenn kein leerer Eintrag
     set acmd [split $search "&"]			   ;# Eintrag bei "&" aufsplitten
     set inick [lindex $acmd 0]			   ;# erstes Argument ist Nick
     set inick [form $inick]				   ;# Nick formatieren
     set ichan [lrange $acmd 1 end]			   ;# Der gesamte Rest ist der Channel
     set ichan [form $ichan]				   ;# Chan formatieren
     putlog "$inick       $ichan"	 	  	   ;# Zeile anzeigen
     }							   ;# End if (search)
    }								   ;# End foreach
  } else {							   ;# Falls keine Struktur vorhanden
    putlog "Keine Daten gespeichert"		   ;# Fehler anzeigen
  }								   ;# End if
}								   ;# End Procedure

proc add_users {handle idx args} {
 global iok_nick iok_ni					   ;# Datenstrukturen public definieren
 set acmd [lindex $args 0]				   ;# Befehlszeile extrahieren
 set inick [lindex $acmd 0]				   ;# erstes Argument ist Nick
 set inick [form $inick]				   ;# Nick formatieren
 set ichan [lrange $acmd 1 end]			   ;# Der gesamte Rest ist der Channel
 set ichan [form $ichan]				   ;# Chan formatieren
 set ientry "$inick&$ichan"				   ;# Kombination Nick&Chan bauen
 set iok_nick($ientry) $ientry                     ;# Array Datenfeld (neu) belegen
 writefile							   ;# Datei schreiben
 putlog "User $inick mit Chan $ichan in $iok_ni(datafile) hinzugefgt"
}								   ;# End Procedure

proc del_users {handle idx args} {
 global iok_nick iok_ni					   ;# Datenstrukturen public definieren
 set acmd [lindex $args 0]				   ;# Befehlszeile extrahieren
 set inick [lindex $acmd 0]				   ;# erstes Argument ist Nick
 set inick [form $inick]				   ;# Nick formatieren
 set ichan [lrange $acmd 1 end]			   ;# Der gesamte Rest ist der Channel
 set ichan [form $ichan]				   ;# Chan formatieren
 set ientry "$inick&$ichan"				   ;# Eintrag nick&chan montieren
 if {([info exists iok_nick($ientry)])} {          ;# wenn der Eintrag existiert 
   unset iok_nick($ientry)				   ;# Array Datenfeld freigeben
   writefile
   putlog "Eintrag $ientry aus $iok_ni(datafile) gelscht"  ;# Lschmeldung
   } else {							   ;# Falls nick nicht vorhanden
   putlog "Eintrag $ientry ist nicht gespeichert!"     ;# Infomeldung
   }								   ;# End if (info)
}								   ;# End Procedure

proc kinvite {nick uhost hand text {dest ""}} {	   ;# Die Hauptroutine
  global botnick iok_nick				   ;# globale Variablen deklarieren
  if {$dest == ""} {set dest $botnick}
  set cf "0"						   ;# Flag lschen
  set ktext $text						   ;# erst mal angegebenen Text holen
  set khost [lindex $ktext 2]			   	   ;# aus Text den Host extrahieren
  set klnick [split $khost "!"]			   ;# Host am "!" aufsplitten
  set knick [string tolower [lindex $klnick 0]]	   ;# und Host extrahieren
  set kreason [lrange $ktext 3 end]			   ;# Grund extrahieren
  set kchan [string trimleft $dest "@"]		   ;# Zielchannel extrahieren
  if {![iok:active $kchan]} {				   ;# prfen, ob chan aktiv
    putlog "Anfrage fr inaktiven Channel $kchan von $knick"
    putquick "Notice $knick : Im angefragten Channel erfolgt zumindest kein automatisches invite. Aber vielleicht lt dich ja auch so jemand rein...."
    return 0 						   ;# inaktiver Chan --> Ende
    }								   ;# end if (active)
  foreach search [array names iok_nick] {		   ;# Liste aller Eintrge durchlaufen
    if {$search != 0} {					   ;# wenn kein leerer Eintrag
      set ientry $iok_nick($search)			   ;# Eintrag (nick&#chan) extrahieren
      set parts [split $ientry "&"]
      set inick [lindex $parts 0]		   	   ;# Nick extrahieren
      set ichan [lindex $parts 1]		   	   ;# Chan extrahieren
      if {([string tolower $inick] == [string tolower $knick]) && ([string tolower $ichan] == [string tolower $kchan])} {  
      # wenn Nick und chan vorhanden
        set cf "1"    					   ;# Flag auf 1
        set xnick $inick
        set xchan $ichan
        break						   ;# foreach Schleife abbrechen
      }							   ;# end if (nickvergleich)
    }								   ;# end if (search !=0)	
   }								   ;# End Foreach
 if {$cf == "1"} {					   ;# wenn Angaben korrekt
    if {[botisop $xchan]} {				   ;# und der bot wirklich op hat	
      putserv "invite $xnick $xchan"		   ;# dann invite durchfhren
    } else {						   ;# bot hat gar kein op
      putlog "Habe kein op op und hole es mir neu" ;# Meldung "kein op"
      putserv "chanserv op $xchan darklord"
      putquick "Notice $knick : Mu mir erst mal op besorgen, versuche es in 1 min nochmal, bitte."
    }								   ;# end if (botisop)
  } else {							   ;# Flag nicht gesetzt (etwas ist falsch)
    putlog "Falscher Nick oder falscher Chan ($knick, $kchan)"	   ;# Meldung "falsch"
    putquick "Notice $knick : Du bist in Chan $kchan nicht fr automatisches Einladen eingetragen."
  }								   ;# end if (cf)
}								   ;# end procedure

proc form {formtext} {					   ;# Formatierung String
  set t [string trimleft $formtext]			   ;# fhrende Leerzeichen entfernen
  set t [string trimright $t]				   ;# folgende Leerzeichen entfernen
  return $t							   ;# formatierten String zurckliefern
}

proc writefile {} {
  global iok_nick iok_ni
  set out [open $iok_ni(datafile) w]		   ;# Datenfile im w modus ffnen (berschreiben)
  foreach search [array names iok_nick] {		   ;# durchlaufen der Daten arrays
    if {$search != 0} {					   ;# wenn keine leere Zeile
      set parts [split $search "&"]			   ;# Eintrag bei "&" aufsplitten
      set inick [lindex $parts 0]			   ;# Nick extrahieren
      set ichan [lindex $parts 1]			   ;# Channel extrahieren
      set output "$inick $ichan"			   ;# Output montieren
      puts $out $output					   ;# Zeile schreiben
     }						         ;# End if (search)
   }								   ;# End Foreach
   close $out						   ;# Datei schlieen
}								   ;# End procedure

proc iok:active {chan} {
  foreach setting [channel info $chan] {		;# "channel info" ist ein TCL Befehl!
    if {[regexp -- {^[\+-]} $setting]} {
      if {$setting == "+iok"} { return 1 }
    }
  }
  return 0
}

putlog "iok (invite on knock) von stylus740 geladen. (Stand 29.03.03)"
putlog "Eingabe von \.iokhelp zeigt Bedienungshinweise an"
